
public class TestInterpreter
{
   
 

   
    public static void main(String[] args)
    {
        Context c=new Context();
        
        Expression c1 = new Terminal ("a");
        Expression c2 = new Terminal ("b");
        Expression c3 = new Terminal ("c");
        Expression c4 = new Terminal ("d");
        
        System.out.println("a: " +c1.interpret(c));
        System.out.println("b: " +c2.interpret(c));
        System.out.println("c: " +c3.interpret(c));
        System.out.println("d: " +c4.interpret(c));
        
        Expression orc1c2 = new Or(c1,c2);
        System.out.println("a or b: " +orc1c2.interpret(c));
        
        Expression andc1c2 = new And(c1,c2);
        System.out.println("a and b: " +andc1c2.interpret(c));
        
        Expression negc1 = new Negation(c1);
        System.out.println("not a: " +negc1.interpret(c));
        
        Expression complex = new Or(negc1, andc1c2);
        System.out.println("not a or (b abd c): " +complex.interpret(c));
        
        
        
        

        
    }
}
